Netdev Archive mirror
 help / color / mirror / Atom feed
* [PATCH net] selftests: net: move amt to socat for better compatibility
@ 2024-05-09 16:19 Jakub Kicinski
  2024-05-09 17:39 ` Paolo Abeni
                   ` (2 more replies)
  0 siblings, 3 replies; 5+ messages in thread
From: Jakub Kicinski @ 2024-05-09 16:19 UTC (permalink / raw
  To: davem
  Cc: netdev, edumazet, pabeni, Jakub Kicinski, shuah, ap420073,
	linux-kselftest

The test seems to expect that nc will exit after the first
received message. This is not the case with Ncat 7.94.
There are multiple versions of nc out there, switch
to socat for better compatibility.

Tell socat to exit after 128 bytes and pad the message.

Since the test sets -e make sure we don't set exit code
(|| true) and print the pass / fail rather then silently
moving over the test and just setting non-zero exit code
with no output indicating what failed.

Fixes: c08e8baea78e ("selftests: add amt interface selftest script")
Signed-off-by: Jakub Kicinski <kuba@kernel.org>
---
CC: shuah@kernel.org
CC: ap420073@gmail.com
CC: linux-kselftest@vger.kernel.org
---
 tools/testing/selftests/net/amt.sh | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

diff --git a/tools/testing/selftests/net/amt.sh b/tools/testing/selftests/net/amt.sh
index 75528788cb95..5175a42cbe8a 100755
--- a/tools/testing/selftests/net/amt.sh
+++ b/tools/testing/selftests/net/amt.sh
@@ -210,8 +210,8 @@ check_features()
 
 test_ipv4_forward()
 {
-	RESULT4=$(ip netns exec "${LISTENER}" nc -w 1 -l -u 239.0.0.1 4000)
-	if [ "$RESULT4" == "172.17.0.2" ]; then
+	RESULT4=$(ip netns exec "${LISTENER}" timeout 15 socat - UDP4-LISTEN:4000,readbytes=128 || true)
+	if echo "$RESULT4" | grep -q "172.17.0.2"; then
 		printf "TEST: %-60s  [ OK ]\n" "IPv4 amt multicast forwarding"
 		exit 0
 	else
@@ -222,8 +222,8 @@ test_ipv4_forward()
 
 test_ipv6_forward()
 {
-	RESULT6=$(ip netns exec "${LISTENER}" nc -w 1 -l -u ff0e::5:6 6000)
-	if [ "$RESULT6" == "2001:db8:3::2" ]; then
+	RESULT6=$(ip netns exec "${LISTENER}" timeout 15 socat - UDP6-LISTEN:6000,readbytes=128 || true)
+	if echo "$RESULT6" | grep -q "2001:db8:3::2"; then
 		printf "TEST: %-60s  [ OK ]\n" "IPv6 amt multicast forwarding"
 		exit 0
 	else
@@ -236,14 +236,14 @@ send_mcast4()
 {
 	sleep 2
 	ip netns exec "${SOURCE}" bash -c \
-		'echo 172.17.0.2 | nc -w 1 -u 239.0.0.1 4000' &
+		'printf "%s %128s" 172.17.0.2 | nc -w 1 -u 239.0.0.1 4000' &
 }
 
 send_mcast6()
 {
 	sleep 2
 	ip netns exec "${SOURCE}" bash -c \
-		'echo 2001:db8:3::2 | nc -w 1 -u ff0e::5:6 6000' &
+		'printf "%s %128s" 2001:db8:3::2 | nc -w 1 -u ff0e::5:6 6000' &
 }
 
 check_features
-- 
2.45.0


^ permalink raw reply related	[flat|nested] 5+ messages in thread

* Re: [PATCH net] selftests: net: move amt to socat for better compatibility
  2024-05-09 16:19 [PATCH net] selftests: net: move amt to socat for better compatibility Jakub Kicinski
@ 2024-05-09 17:39 ` Paolo Abeni
  2024-05-09 18:42   ` Jakub Kicinski
  2024-05-10  6:09 ` Taehee Yoo
  2024-05-11  1:30 ` patchwork-bot+netdevbpf
  2 siblings, 1 reply; 5+ messages in thread
From: Paolo Abeni @ 2024-05-09 17:39 UTC (permalink / raw
  To: Jakub Kicinski, davem; +Cc: netdev, edumazet, shuah, ap420073, linux-kselftest

On Thu, 2024-05-09 at 09:19 -0700, Jakub Kicinski wrote:
> The test seems to expect that nc will exit after the first
> received message. This is not the case with Ncat 7.94.
> There are multiple versions of nc out there, switch
> to socat for better compatibility.
> 
> Tell socat to exit after 128 bytes and pad the message.
> 
> Since the test sets -e make sure we don't set exit code
> (|| true) and print the pass / fail rather then silently
> moving over the test and just setting non-zero exit code
> with no output indicating what failed.
> 
> Fixes: c08e8baea78e ("selftests: add amt interface selftest script")
> Signed-off-by: Jakub Kicinski <kuba@kernel.org>
> ---
> CC: shuah@kernel.org
> CC: ap420073@gmail.com
> CC: linux-kselftest@vger.kernel.org
> ---
>  tools/testing/selftests/net/amt.sh | 12 ++++++------
>  1 file changed, 6 insertions(+), 6 deletions(-)
> 
> diff --git a/tools/testing/selftests/net/amt.sh b/tools/testing/selftests/net/amt.sh
> index 75528788cb95..5175a42cbe8a 100755
> --- a/tools/testing/selftests/net/amt.sh
> +++ b/tools/testing/selftests/net/amt.sh
> @@ -210,8 +210,8 @@ check_features()
>  
>  test_ipv4_forward()
>  {
> -	RESULT4=$(ip netns exec "${LISTENER}" nc -w 1 -l -u 239.0.0.1 4000)
> -	if [ "$RESULT4" == "172.17.0.2" ]; then
> +	RESULT4=$(ip netns exec "${LISTENER}" timeout 15 socat - UDP4-LISTEN:4000,readbytes=128 || true)
> +	if echo "$RESULT4" | grep -q "172.17.0.2"; then
>  		printf "TEST: %-60s  [ OK ]\n" "IPv4 amt multicast forwarding"
>  		exit 0
>  	else
> @@ -222,8 +222,8 @@ test_ipv4_forward()
>  
>  test_ipv6_forward()
>  {
> -	RESULT6=$(ip netns exec "${LISTENER}" nc -w 1 -l -u ff0e::5:6 6000)
> -	if [ "$RESULT6" == "2001:db8:3::2" ]; then
> +	RESULT6=$(ip netns exec "${LISTENER}" timeout 15 socat - UDP6-LISTEN:6000,readbytes=128 || true)
> +	if echo "$RESULT6" | grep -q "2001:db8:3::2"; then

The patch LGTM:

Acked-by: Paolo Abeni<pabeni@redhat.com>

As a minor note, shell variable expansion should already trim all the
trailing/leading spaces from the socat command output, so it should not
be necessary replace the string comparison with the grep command:

	RESULT6=$(ip netns exec "${LISTENER}" timeout 15 socat - UDP6-LISTEN:6000,readbytes=128 || true)
	if [ "$RESULT6" == "2001:db8:3::2" ]; then

Should work

Cheers,

Paolo


^ permalink raw reply	[flat|nested] 5+ messages in thread

* Re: [PATCH net] selftests: net: move amt to socat for better compatibility
  2024-05-09 17:39 ` Paolo Abeni
@ 2024-05-09 18:42   ` Jakub Kicinski
  0 siblings, 0 replies; 5+ messages in thread
From: Jakub Kicinski @ 2024-05-09 18:42 UTC (permalink / raw
  To: Paolo Abeni; +Cc: davem, netdev, edumazet, shuah, ap420073, linux-kselftest

On Thu, 09 May 2024 19:39:36 +0200 Paolo Abeni wrote:
> Acked-by: Paolo Abeni<pabeni@redhat.com>

Thanks!

> As a minor note, shell variable expansion should already trim all the
> trailing/leading spaces from the socat command output, so it should not
> be necessary replace the string comparison with the grep command:
> 
> 	RESULT6=$(ip netns exec "${LISTENER}" timeout 15 socat - UDP6-LISTEN:6000,readbytes=128 || true)
> 	if [ "$RESULT6" == "2001:db8:3::2" ]; then

99% sure I tried that exact thing, but it wasn't enough.

$ msg=$(socat - UDP4-LISTEN:1234,readbytes=128)
$ echo ">$msg<"
>127.0.0.1                                                                                                                       <
$ msg=$msg
$ echo ">$msg<"
>127.0.0.1                                                                                                                       <
$ msg=$(echo $msg)
$ echo ">$msg<"
>127.0.0.1<


IOW we'd need to feed it thru an echo or some such.
Possibly something like: [ $(echo $msg) == "127.0.0.1" ]
But I personally find that a touch too magical.
The grep works 🤷️

^ permalink raw reply	[flat|nested] 5+ messages in thread

* Re: [PATCH net] selftests: net: move amt to socat for better compatibility
  2024-05-09 16:19 [PATCH net] selftests: net: move amt to socat for better compatibility Jakub Kicinski
  2024-05-09 17:39 ` Paolo Abeni
@ 2024-05-10  6:09 ` Taehee Yoo
  2024-05-11  1:30 ` patchwork-bot+netdevbpf
  2 siblings, 0 replies; 5+ messages in thread
From: Taehee Yoo @ 2024-05-10  6:09 UTC (permalink / raw
  To: Jakub Kicinski; +Cc: davem, netdev, edumazet, pabeni, shuah, linux-kselftest

On Fri, May 10, 2024 at 1:19 AM Jakub Kicinski <kuba@kernel.org> wrote:
>

Hi Jakub,
Thanks a lot for this work!

> The test seems to expect that nc will exit after the first
> received message. This is not the case with Ncat 7.94.
> There are multiple versions of nc out there, switch
> to socat for better compatibility.
>
> Tell socat to exit after 128 bytes and pad the message.
>
> Since the test sets -e make sure we don't set exit code
> (|| true) and print the pass / fail rather then silently
> moving over the test and just setting non-zero exit code
> with no output indicating what failed.
>
> Fixes: c08e8baea78e ("selftests: add amt interface selftest script")
> Signed-off-by: Jakub Kicinski <kuba@kernel.org>
> ---
> CC: shuah@kernel.org
> CC: ap420073@gmail.com
> CC: linux-kselftest@vger.kernel.org
> ---
>  tools/testing/selftests/net/amt.sh | 12 ++++++------
>  1 file changed, 6 insertions(+), 6 deletions(-)
>
> diff --git a/tools/testing/selftests/net/amt.sh b/tools/testing/selftests/net/amt.sh
> index 75528788cb95..5175a42cbe8a 100755
> --- a/tools/testing/selftests/net/amt.sh
> +++ b/tools/testing/selftests/net/amt.sh
> @@ -210,8 +210,8 @@ check_features()
>
>  test_ipv4_forward()
>  {
> -       RESULT4=$(ip netns exec "${LISTENER}" nc -w 1 -l -u 239.0.0.1 4000)
> -       if [ "$RESULT4" == "172.17.0.2" ]; then
> +       RESULT4=$(ip netns exec "${LISTENER}" timeout 15 socat - UDP4-LISTEN:4000,readbytes=128 || true)
> +       if echo "$RESULT4" | grep -q "172.17.0.2"; then
>                 printf "TEST: %-60s  [ OK ]\n" "IPv4 amt multicast forwarding"
>                 exit 0
>         else
> @@ -222,8 +222,8 @@ test_ipv4_forward()
>
>  test_ipv6_forward()
>  {
> -       RESULT6=$(ip netns exec "${LISTENER}" nc -w 1 -l -u ff0e::5:6 6000)
> -       if [ "$RESULT6" == "2001:db8:3::2" ]; then
> +       RESULT6=$(ip netns exec "${LISTENER}" timeout 15 socat - UDP6-LISTEN:6000,readbytes=128 || true)
> +       if echo "$RESULT6" | grep -q "2001:db8:3::2"; then
>                 printf "TEST: %-60s  [ OK ]\n" "IPv6 amt multicast forwarding"
>                 exit 0
>         else
> @@ -236,14 +236,14 @@ send_mcast4()
>  {
>         sleep 2
>         ip netns exec "${SOURCE}" bash -c \
> -               'echo 172.17.0.2 | nc -w 1 -u 239.0.0.1 4000' &
> +               'printf "%s %128s" 172.17.0.2 | nc -w 1 -u 239.0.0.1 4000' &
>  }
>
>  send_mcast6()
>  {
>         sleep 2
>         ip netns exec "${SOURCE}" bash -c \
> -               'echo 2001:db8:3::2 | nc -w 1 -u ff0e::5:6 6000' &
> +               'printf "%s %128s" 2001:db8:3::2 | nc -w 1 -u ff0e::5:6 6000' &
>  }
>
>  check_features
> --
> 2.45.0
>

Tested-by: Taehee Yoo <ap420073@gmail.com>

^ permalink raw reply	[flat|nested] 5+ messages in thread

* Re: [PATCH net] selftests: net: move amt to socat for better compatibility
  2024-05-09 16:19 [PATCH net] selftests: net: move amt to socat for better compatibility Jakub Kicinski
  2024-05-09 17:39 ` Paolo Abeni
  2024-05-10  6:09 ` Taehee Yoo
@ 2024-05-11  1:30 ` patchwork-bot+netdevbpf
  2 siblings, 0 replies; 5+ messages in thread
From: patchwork-bot+netdevbpf @ 2024-05-11  1:30 UTC (permalink / raw
  To: Jakub Kicinski
  Cc: davem, netdev, edumazet, pabeni, shuah, ap420073, linux-kselftest

Hello:

This patch was applied to netdev/net.git (main)
by Jakub Kicinski <kuba@kernel.org>:

On Thu,  9 May 2024 09:19:52 -0700 you wrote:
> The test seems to expect that nc will exit after the first
> received message. This is not the case with Ncat 7.94.
> There are multiple versions of nc out there, switch
> to socat for better compatibility.
> 
> Tell socat to exit after 128 bytes and pad the message.
> 
> [...]

Here is the summary with links:
  - [net] selftests: net: move amt to socat for better compatibility
    https://git.kernel.org/netdev/net/c/4c639b6a7b9d

You are awesome, thank you!
-- 
Deet-doot-dot, I am a bot.
https://korg.docs.kernel.org/patchwork/pwbot.html



^ permalink raw reply	[flat|nested] 5+ messages in thread

end of thread, other threads:[~2024-05-11  1:30 UTC | newest]

Thread overview: 5+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2024-05-09 16:19 [PATCH net] selftests: net: move amt to socat for better compatibility Jakub Kicinski
2024-05-09 17:39 ` Paolo Abeni
2024-05-09 18:42   ` Jakub Kicinski
2024-05-10  6:09 ` Taehee Yoo
2024-05-11  1:30 ` patchwork-bot+netdevbpf

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).